import { __decorate } from 'tslib';
import { ɵɵdefineInjectable, Injectable, ɵɵinject, NgModule } from '@angular/core';
import { Storage, IonicStorageModule } from '@ionic/storage';

var IonicStorageService = /** @class */ (function () {
    function IonicStorageService() {
    }
    IonicStorageService.ɵprov = ɵɵdefineInjectable({ factory: function IonicStorageService_Factory() { return new IonicStorageService(); }, token: IonicStorageService, providedIn: "root" });
    IonicStorageService = __decorate([
        Injectable({
            providedIn: 'root'
        })
    ], IonicStorageService);
    return IonicStorageService;
}());

var IonicTokenService = /** @class */ (function () {
    function IonicTokenService(storage) {
        this.storage = storage;
        this.tokenName = 'api_refresh_token';
    }
    IonicTokenService.prototype.getRefreshToken = function () {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this.storage.get(_this.tokenName).then(function (value) {
                resolve(value);
            }).catch(function () {
                reject();
            });
        });
    };
    IonicTokenService.prototype.deleteRefreshToken = function () {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this.storage.remove(_this.tokenName).then(function () {
                resolve(null);
            }).catch(function () {
                reject();
            });
        });
    };
    IonicTokenService.prototype.setRefreshToken = function (token) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this.storage.set(_this.tokenName, token).then(function () {
                resolve(null);
            }).catch(function () {
                reject();
            });
        });
    };
    IonicTokenService.ctorParameters = function () { return [
        { type: Storage }
    ]; };
    IonicTokenService.ɵprov = ɵɵdefineInjectable({ factory: function IonicTokenService_Factory() { return new IonicTokenService(ɵɵinject(Storage)); }, token: IonicTokenService, providedIn: "root" });
    IonicTokenService = __decorate([
        Injectable({
            providedIn: 'root'
        })
    ], IonicTokenService);
    return IonicTokenService;
}());

var IonicCacheService = /** @class */ (function () {
    function IonicCacheService(storage) {
        this.storage = storage;
        this.prefix = 'io-cache-';
    }
    /**
     * Add Data to Cache
     * @param key
     *  Cache Key
     * @param data
     *  Data to cache
     * @param expire
     *  Expiration in seconds. Optional, default: 900 (i.e. 15 minutes)
     */
    IonicCacheService.prototype.set = function (key, data, expire) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            if (expire === undefined) {
                expire = 900;
            }
            var ex = new Date();
            ex.setSeconds(ex.getSeconds() + expire);
            var cache = {
                key: key,
                data: data,
                expire: ex,
            };
            _this.storage.set(_this.prefix + key, cache).then(function () {
                resolve(null);
            }).catch(function (error) {
                reject(error);
            });
        });
    };
    /**
     * Get data from Cache
     * @param key
     *  Cache Key
     *
     * The request is rejected, if no data exists or data is expired.
     */
    IonicCacheService.prototype.get = function (key) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this.storage.get(_this.prefix + key).then(function (cache) {
                var now = new Date();
                var expire = new Date(cache.expire);
                if (expire > now) {
                    resolve(cache.data);
                }
                else {
                    _this.storage.remove(_this.prefix + key);
                    reject();
                }
            }).catch(function (error) {
                reject();
            });
        });
    };
    IonicCacheService.ctorParameters = function () { return [
        { type: Storage }
    ]; };
    IonicCacheService.ɵprov = ɵɵdefineInjectable({ factory: function IonicCacheService_Factory() { return new IonicCacheService(ɵɵinject(Storage)); }, token: IonicCacheService, providedIn: "root" });
    IonicCacheService = __decorate([
        Injectable({
            providedIn: 'root'
        })
    ], IonicCacheService);
    return IonicCacheService;
}());

var IonicDataStorageModule = /** @class */ (function () {
    function IonicDataStorageModule() {
    }
    IonicDataStorageModule = __decorate([
        NgModule({
            imports: [
                IonicStorageModule.forRoot(),
            ],
        })
    ], IonicDataStorageModule);
    return IonicDataStorageModule;
}());

/*
 * Public API Surface of ionic-storage
 */

/**
 * Generated bundle index. Do not edit.
 */

export { IonicCacheService, IonicDataStorageModule, IonicStorageService, IonicTokenService };
//# sourceMappingURL=attus-ionic-storage.js.map
