import { Storage } from '@ionic/storage';
export declare class IonicCacheService {
    private storage;
    private prefix;
    constructor(storage: Storage);
    /**
     * Add Data to Cache
     * @param key
     *  Cache Key
     * @param data
     *  Data to cache
     * @param expire
     *  Expiration in seconds. Optional, default: 900 (i.e. 15 minutes)
     */
    set(key: string, data: any, expire?: number): Promise<unknown>;
    /**
     * Get data from Cache
     * @param key
     *  Cache Key
     *
     * The request is rejected, if no data exists or data is expired.
     */
    get(key: string): Promise<any>;
}
export interface IonicCacheData {
    key: string;
    data: any;
    expire: Date;
}
